SET NOCOUNT ON;
DECLARE @sql_command NVARCHAR(MAX);

IF EXISTS (SELECT * FROM tempdb.sys.tables WHERE tables.name LIKE '#distinct_view_list%')
BEGIN
	DROP TABLE #distinct_view_list;
END
CREATE TABLE #distinct_view_list
	(distinct_view_list_id INT NOT NULL IDENTITY(1,1) PRIMARY KEY CLUSTERED,
	 view_schema_name SYSNAME NOT NULL,
	 view_name SYSNAME NOT NULL);

INSERT INTO #distinct_view_list
	(view_schema_name, view_name)
SELECT
	schemas.name AS view_schema_name,
	views.name AS view_name
FROM sys.views
INNER JOIN sys.schemas
ON schemas.schema_id = views.schema_id;

SELECT @sql_command = '';
SELECT
	@sql_command = @sql_command + '
	BEGIN TRY
		SELECT TOP 1 *
		FROM [' + CAST(distinct_view_list.view_schema_name AS VARCHAR(MAX)) + '].[' + CAST(distinct_view_list.view_name AS VARCHAR(MAX)) + '];
	END TRY
	BEGIN CATCH
		PRINT ''The following view is broken via DML errors from a SELECT * FROM query: ' + CAST(distinct_view_list.view_schema_name AS VARCHAR(MAX)) + '.' + CAST(distinct_view_list.view_name AS VARCHAR(MAX)) + '
Error Message: '' + ERROR_MESSAGE();

		IF @@TRANCOUNT > 0
		BEGIN
			ROLLBACK;
		END
	END CATCH;'
FROM #distinct_view_list distinct_view_list

EXEC sp_executesql @sql_command;
DROP TABLE #distinct_view_list;